function DVSet = CorrelationAnalysis(Population,ObjValue,DV,nCor,problem,Boundary)
% Detect the group of each distance variable

% Copyright 2015-2016 Ye Tian
    
    DVSet = {};
    for v = DV
        RelatedSet = [];
        for d = 1 : length(DVSet)
            for u = DVSet{d}
                sign = false;
                for i = 1 : nCor
                    p    = randi(size(Population,1));
                    a2   = rand*(Boundary(1,v)-Boundary(2,v)) + Boundary(2,v);
                    b2   = rand*(Boundary(1,u)-Boundary(2,u)) + Boundary(2,u);
                    decs = repmat(Population(p,:),3,1);
                    decs(1,v)     = a2;
                    decs(2,u)     = b2;
                    decs(3,[v,u]) = [a2,b2];
                    nObjValue     = F_objective('value',problem,size(ObjValue,2),decs);
                    delta1 = nObjValue(1,:) - ObjValue(p,:);
                    delta2 = nObjValue(3,:) - nObjValue(2,:);
                    if any(delta1.*delta2<0)
                        sign = true;
                        RelatedSet = [RelatedSet,d];
                        break;
                    end
                end
                if sign
                    break;
                end
            end
        end
        if isempty(RelatedSet)
            DVSet = [DVSet,v];
        else
            DVSet = [DVSet,[cell2mat(DVSet(RelatedSet)),v]];
            DVSet(RelatedSet) = [];
        end
    end
end